<?php
/**
 * @package Random Code Generator
 * @author Joe Casabona
 * @version 1.0
 */
 
/*
Plugin Name: Random Code Generator
Plugin URI: http://www.manifestdevelopment.com/wordpress-packages/code-generator/
Description: A simple plugin that genrates a random string of characters and stores it in a database. Good for generating promotional codes 
Author: Joe Casabona
Version: 1.0
Author URI: http://www.casabona.org
*/

//some set-up.
define('RNDCODE_PATH', WP_PLUGIN_URL . '/' . plugin_basename( dirname(__FILE__) ) . '/' );
define('RNDCODE_NAME', "Random Code Generator");
define('RNDCODE_CREDIT_LINK', 'Brought to you by: <a href="http://www.manifestdevelopment.com">Joe Casabona</a>');
$table_name= "";
$rndcode_db_version= 1.0;

//Install the database tables if we need to.
function rndcode_install(){
global $wpdb, $table_name;
global $rndcode_db_version;
require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

 $table_name = $wpdb->prefix . "rndcode_codes";
   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
		
	$sql_rndcode= ("
		CREATE TABLE `$table_name` (
  		`cID` mediumint(9) NOT NULL auto_increment,
  		`code` text NOT NULL,
  		`used` tinyint NOT NULL,
  		PRIMARY KEY  (`cID`)
		);
	");
	
	dbDelta($sql_rndcode);
	
	}
	
	add_option("rndcode_db_version", $rndcode_db_version);

}
	

add_action('init', 'rndcode_install');



//build the admin panel page (probably going to expand more on this...)
function rndcode_admin(){
	add_submenu_page('tools.php', 'Tools', RNDCODE_NAME, 8, __FILE__, 'rndcode_admin_page');
}
	
add_action('admin_menu', 'rndcode_admin');

function rndcode_admin_page(){
	echo('
	<div style="width: 730px; margin: 0 auto;">
		<h2>'. RNDCODE_NAME .'</h2>
		<p>Here you can view all of the codes generated by the plug-in. Future builds will probably have a way to delete, or at least mark as used. This plug-in was developed by <a href="http://www.manifestdevelopment.com">Joe Casabona</a>. Official webpage <a href="http://www.manifestdevelopment.com/wordpress-packages/code-generator/">here</a>. If you like it, <a  target="_blank" href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=6650099">a little scratch</a> would be nice!</p>
		
		<p>*TIP: Quickly find a code by using Ctrl+F (Windows) or Command+F (Mac)</p>
		
		<h3>Codes Generated:</h3>
	
	');	
	
	rndcode_print_all_codes();
	
	echo '</div>';
	
}

//template tags!
function rndcode_generate_code($length=10){
	global $wpdb, $table_name;
	$candidates= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwzyz0123456789!@!@#$%^&*()";
	$size= strlen($candidates);
	$i= 0;
	$inDB= true;
	$text= "";
	do{
		while($i < $length){
			$text.= substr($candidates, mt_rand(0, strlen($candidates)-1), 1);
			$i++;
		}
		
		if($wpdb->get_var("SELECT cID FROM $table_name WHERE code= '$text' AND used= 0") == NULL){ $inDB= false; }
		
	
	} while($inDB);
	
	$wpdb->query("INSERT INTO $table_name VALUES('', '$text', '0')");
	return $text;
}


function rndcode_print_code(){
		$code= rndcode_generate_code();
	
	echo('
		<span class="rndcode_code">
			'. $code .'
		</span>
		<p class="small">'. RNDCODE_CREDIT_LINK .'</p>
	');	
	
}

function rndcode_print_all_codes(){
global $wpdb, $table_name;
	$codes= $wpdb->get_results("SELECT code FROM $table_name WHERE used=0");
	print "<ul style=\"margin-left: 30px; font-size: 1.4em;\">";
	foreach($codes as $c){
		print "<li style=\"margin: 10px; float: left;\">{$c->code}</li>";	
	}
	print "</ul>";
}


?>
